=== debian/changelog ===
dart (6.13.2+ds-0ubuntu3) noble; urgency=medium

  * Allow stderr output in autopkgtest

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 24 Apr 2024 22:40:57 +0000

dart (6.13.2+ds-0ubuntu2) noble; urgency=medium

  * Build package on riscv64 again. It's a 64-bit architecture.

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 24 Apr 2024 13:04:02 +0200

dart (6.13.2+ds-0ubuntu1) noble; urgency=medium

  * Restrict package to 64bits. Upstream does not support 32bits
  * New upstream version 6.13.2+ds (LP: #2053254)
  * Rename files from 6.12t64 to 6.13
  * Rediff patches
  * Update dependencies in d/control
  * Include file in utils
  * Back to enable freeglut in b-dep
  * Added libfmt-dev dependency
  * Correct multi-arch declarations
  * Remove deleted file from d/copyright
  * Disable STL related test in d/rules for s390
    See https://github.com/assimp/assimp/issues/5509

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 23 Apr 2024 16:27:55 +0200

dart (6.12.1+dfsg4-13.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:00:21 +0000
