=== debian/control ===
Source: dart
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: architecture-is-64-bit,
               debhelper-compat (= 13),
               cmake,
               coinor-libipopt-dev,
               doxygen,
               dh-sequence-python3,
               libeigen3-dev,
               libccd-dev,
               libfcl-dev,
               libbullet-dev,
               libode-dev,
               libassimp-dev,
               libnlopt-cxx-dev,
               libxi-dev,
               libxmu-dev,
               libtinyxml-dev,
               libtinyxml2-dev,
               liburdfdom-dev,
               liboctomap-dev,
               libopenthreads-dev,
               libopenscenegraph-dev,
               libspdlog-dev,
               libfmt-dev,
               freeglut3-dev,
               googletest,
               pybind11-dev,
               python3-all-dev,
               python3-numpy,
               python3-pytest,
               jdupes
Standards-Version: 4.6.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/dart
Vcs-Git: https://salsa.debian.org/science-team/dart.git
Homepage: http://dartsim.github.io/
Description: Kinematics Dynamics and Optimization Library
 DART is a collaborative, cross-platform, open source library created by the
 Georgia Tech Graphics Lab and Humanoid Robotics Lab. The library provides data
 structures and algorithms for kinematic and dynamic applications in robotics
 and computer animation.
 DART is distinguished by it's accuracy and stability due to its use of
 generalized coordinates to represent articulated rigid body systems and
 computation of Lagrange's equations derived from D.Alembert's principle to
 describe the dynamics of motion.
 For developers, in contrast to many popular physics engines which view the
 simulator as a black box, DART gives full access to internal kinematic and
 dynamic quantities, such as the mass matrix, Coriolis and centrifugal forces,
 transformation matrices and their derivatives. DART also provides efficient
 computation of Jacobian matrices for arbitrary body points and coordinate
 frames. Contact and collision are handled using an implicit time-stepping,
 velocity-based LCP (linear-complementarity problem) to guarantee
 non-penetration, directional friction, and approximated Coulomb friction cone
 conditions. For collision detection, DART uses FCL developed by Willow Garage
 and the UNC Gamma Lab.
 DART has applications in robotics and computer animation because it features a
 multibody dynamic simulator and tools for control and motion planning.
 Multibody dynamic simulation in DART is an extension of RTQL8, an open source
 software created by the Georgia Tech Graphics Lab.

Package: libdart-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
         libdart6.13 (= ${binary:Version}),
         libeigen3-dev,
         libassimp-dev,
         libfcl-dev,
         libbullet-dev,
         libspdlog-dev,
         libdart-external-odelcpsolver-dev,
         libdart-external-convhull-3d-dev
Pre-Depends: ${misc:Pre-Depends}
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 This package contains main headers and other tools for development.

Package: libdart6.13
Provides: ${t64:Provides}
Architecture: amd64 arm64 ppc64el riscv64 s390x
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ${source:Synopsis} - main library
 ${source:Extended-Description}
 .
 This package contains the main library of DART.

Package: libdart-collision-bullet6.13
Provides: ${t64:Provides}
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: ${source:Synopsis} - Bullet Collision Library
 ${source:Extended-Description}
 .
 This package contains the collision library with Bullet backend.

Package: libdart-collision-bullet-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
         libdart-dev,
         libdart-collision-bullet6.13 (= ${binary:Version}),
         libbullet-dev
Pre-Depends: ${misc:Pre-Depends}
Description: ${source:Synopsis} - Bullet Collision Dev
 ${source:Extended-Description}

Package: libdart-collision-ode6.13
Provides: ${t64:Provides}
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: ${source:Synopsis} - ODE Collision Library
 ${source:Extended-Description}
 .
 This package contains the collision library with ODE backend.

Package: libdart-collision-ode-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
         libdart-dev,
         libdart-collision-ode6.13 (= ${binary:Version}),
         libode-dev
Pre-Depends: ${misc:Pre-Depends}
Description: ${source:Synopsis} - ODE Collision Dev
 ${source:Extended-Description}
 .
 This package contains the collision ode headers and other tools for
 development.

Package: libdart-utils-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
         libdart-dev,
         libdart-utils6.13 (= ${binary:Version}),
         libtinyxml-dev,
         libtinyxml2-dev,
         liburdfdom-dev
Pre-Depends: ${misc:Pre-Depends}
Description: ${source:Synopsis} - utils dev files
 ${source:Extended-Description}
 .
 This package contains headers and other useful tools for development.

Package: libdart-utils6.13
Provides: ${t64:Provides}
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: ${source:Synopsis} - utils library
 ${source:Extended-Description}
 .
 This package contains the DART utils library.

Package: libdart-utils-urdf-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
         libdart-dev,
         libdart-utils-dev,
         libdart-utils-urdf6.13 (= ${binary:Version}),
         liburdfdom-dev
Pre-Depends: ${misc:Pre-Depends}
Description: ${source:Synopsis} - URDF Component Development Files
 ${source:Extended-Description}
 .
 This package contains urdf utils headers and other useful tools for
 development.

Package: libdart-utils-urdf6.13
Provides: ${t64:Provides}
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: ${source:Synopsis} - Utils URDF Library
 ${source:Extended-Description}
 .
 This package contains the Utils URDF library.

Package: libdart-gui-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
         libdart-dev,
         libdart-utils-dev,
         libdart-gui6.13 (= ${binary:Version}),
         freeglut3-dev,
         libxi-dev,
         libxmu-dev
Pre-Depends: ${misc:Pre-Depends}
Description: ${source:Synopsis} - gui dev files
 ${source:Extended-Description}
 .
 This package contains GUI headers and other useful tools for GUI development.

Package: libdart-gui6.13
Provides: ${t64:Provides}
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: ${source:Synopsis} - gui library
 ${source:Extended-Description}
 .
 This package contains the GUI library.

Package: libdart-gui-osg-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
         libdart-gui-dev,
         libdart-gui-osg6.13 (= ${binary:Version}),
         libopenthreads-dev,
         libopenscenegraph-dev
Pre-Depends: ${misc:Pre-Depends}
Description: ${source:Synopsis} - gui-osg dev files
 ${source:Extended-Description}
 .
 This package contains GUI OpenSceneGraph headers and other useful tools for
 GUI OpenSceneGraph development.

Package: libdart-gui-osg6.13
Provides: ${t64:Provides}
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: ${source:Synopsis} - gui-osg library
 ${source:Extended-Description}
 .
 This package contains the GUI OpenSceneGraph optimizer library.

Package: libdart-optimizer-nlopt-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
         libdart-dev,
         libdart-optimizer-nlopt6.13 (= ${binary:Version}),
         libnlopt-cxx-dev
Pre-Depends: ${misc:Pre-Depends}
Description: ${source:Synopsis} - nlopt optimizer dev
 ${source:Extended-Description}
 .
 This package contains NLOPT optimizer headers and other useful tools for
 development.

Package: libdart-optimizer-nlopt6.13
Provides: ${t64:Provides}
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: ${source:Synopsis} - nlopt optimizer lib
 ${source:Extended-Description}
 .
 This package contains the NLOPT optimizer library.

Package: libdart-optimizer-ipopt-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
         libdart-dev,
         libdart-optimizer-ipopt6.13 (= ${binary:Version}),
         coinor-libipopt-dev
Pre-Depends: ${misc:Pre-Depends}
Description: ${source:Synopsis} - ipopt optimizer dev
 ${source:Extended-Description}
 .
 This package contains IPOPT optimizer headers and other useful tools for
 development.

Package: libdart-optimizer-ipopt6.13
Provides: ${t64:Provides}
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: ${source:Synopsis} - ipopt optimizer lib
 ${source:Extended-Description}
 .
 This package contains the ipopt optimizer library.

Package: libdart-external-convhull-3d-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: ${source:Synopsis} - convhull-3d dev
 ${source:Extended-Description}
 .
 A header only C implementation of the 3-D quickhull algorithm.

Package: libdart-external-ikfast-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
         libdart-dev
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: no
Description: ${source:Synopsis} - ikfast dev
 ${source:Extended-Description}
 .
 This package contains ikfast headers and other useful tools for
 development.

Package: libdart-external-imgui-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
         libdart-dev,
         libdart-external-imgui6.13 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: ${source:Synopsis} - imgui dev
 ${source:Extended-Description}
 .
 This package contains imgui headers and other useful tools for
 development.

Package: libdart-external-imgui6.13
Provides: ${t64:Provides}
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: ${source:Synopsis} - imgui lib
 ${source:Extended-Description}
 .
 This package contains the imgui library.

Package: libdart-external-lodepng-dev
Architecture: amd64 arm64 ppc64el riscv64 s390x
Section: libdevel
Depends: ${misc:Depends},
         libdart-dev,
