=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs
# Needed to inject correctly the python versions supported
export PYBUILD_SYSTEM=cmake
export PYBUILD_CONFIGURE_ARGS=-DPYVER={version} \
		-DBUILD_SHARED_LIBS=ON \
		-DCMAKE_SKIP_INSTALL_RPATH=ON \
		-DDART_SKIP_FLANN=ON \
		-DDART_SKIP_PAGMO=ON \
		-DDART_VERBOSE=ON \
		-DDARTPY_PYTHON_VERSION={version}

ifneq (,$(filter $(DEB_HOST_ARCH),mips mipsel))
  export DEB_CXXFLAGS_MAINT_APPEND += -g1
endif

# s390 assimp support is broken for STL https://github.com/assimp/assimp/issues/5509
ifeq ($(DEB_HOST_ARCH),s390x)
	export PYBUILD_TEST_ARGS="ARGS+=-E test_MjcfParser\|test_SdfParser\|test_DartLoader\|test_IkFast\|test_ForwardKinematics"
endif

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_install:
	rm -f debian/tmp/usr/share/doc/dart/data/screencap/.KEEP

execute_before_dh_auto_test:
	PYBUILD_BUILD_ARGS="tests" dh_auto_build

override_dh_compress:
	dh_compress \
            -X.hpp -X.h -X.c -X.cpp \
            -X.dae -X.obj -X.stl -X.STL \
            -X.sdf -X.skel -X.urdf -X.vsk -X.world \
            -X.c3d -X.changelog -X.dof -X.path -X.tris

execute_before_dh_link-indep:
	jdupes -rl debian/dart-doc/usr
