=== debian/tests/control ===
Tests: build
Depends: @, cmake, pkg-config, build-essential
Restrictions: allow-stderr
